/* Stata course 1: Stata - Introduction to data access and management */
* Solution to the exercises
********************************************************************************
*Exercise 1
*Task 1:
use "H:\Data\Stata\Original\bhps.dta", clear
*there are 33 variables and 8,602 observations in the dataset

save "H:\Data\Stata\Modified\bhps_save.dta", replace

*Task 2
import excel using "H:\Data\Excel\Original\excel_names.xls", ///
 clear firstrow
*As before, there are 33 variables and 8,602 observations in the dataset
 
export excel using "H:\Data\Excel\Modified\excel_names_save.xls", ///
 replace firstrow(variables)

*Task 3
import excel using "H:\Data\Excel\Original\excel_nonames.xls", ///
 clear
*need to remove the code "firstrow"
*The variables are now named A, B, etc.

*Task 4 - you need to save the .do-file manually, using the 'file' and
* 'save as' buttons

********************************************************************************
*Exercise 2
*task 1:
use "H:\Data\Stata\Original\bhps.dta", clear

list hhid tenure inc_lab country int_month in 1/20
*three of the 20 households rent their accommodation.
* Household 15843238 has declared an income of 0

*task 2:
/* Run the describe command to look at variable descriptions and 
   the name of the value labels. */
describe _all

describe tenure
describe inc_lab
describe country
/* Answers: Country is in string format
	        The value label for tenure is tenure
          The variable label for inc_lab is: "annual household labour income" */
	 
*Task 3.1:
codebook int_month

*Answer: The variable int_month can take values between 1 and 12.
* 8 unique values for the variable are observed in the dataset

*Task 3.2:
describe int_month
label list month
*Answer: The value label for the variable int_month is month - 12 categories
*compare the answers from task 3.1 and 3.2:
* 'label list' lists all defined categories within the value label. codebook 
* shows only the categories used in the dataset

********************************************************************************
*Exercise 3
use "H:\Data\Stata\Original\bhps.dta", clear
*Task 1:
drop toi*

*Task 2:
sort inc_lab

sort int_year hhid

*Task 3:
label list hh_type
*the relevant categories are: 4, 3, 2, 1

keep if house_type == 1 |  house_type == 2 |  ///
 house_type == 3 |  house_type == 4 
*or (maybe more elegantly)
keep if house_type >= 1 & house_type <= 4
*or - even shorter:
keep if house_type <= 4

*Task 4:
gen data2005 = 1 if int_year == 2005
 replace data2005 = 0 if int_year == 2006
 
label define year_2005 1 "Yes (2005)" 0 "No (2006)"
label values data2005 year_2005

label var data2005 "Has the interview been performed in 2005?"
 
 *Task 5:
recode int_year (2006 = 1 "Year 2006") (2005 = 0 "Year 2005"),  ///
 generate(data2006)
 
rename data2006 Interview06
 
*Task 6:
gen lab_percent = inc_lab / inc_total * 100
su lab_percent
*on average, 58% of the total income are due to the labour income for each
*house hold
 
********************************************************************************
*Exercise 4
use "H:\Data\Stata\Original\bhps.dta", clear
*Task 1:
summarize hhcost, detail

*Task 2:
bysort garden: summarize hhcost, detail

*Task 3:
*check the code for a terraced house
label list hh_type
*4!!
summarize hhvalue if house_type == 4, detail

*Task 4:
describe _all
*require variables car_own and garden
tab car_own garden

*Task 5:
tabstat hhvalue, stats(mean p25 p75 sd) by(house_type)

*Task 6:
bysort house_type: tabstat hhvalue, stats(mean p25 p75 sd)

*Task 7:
xtile inc_total_decile=inc_total, nq(10)

*to find out how many observations are in each category:
tab inc_total_decile
*818 observations in each category, and 819 in the first
*There is some missing data within this variable, which is why the categories 
* smaller than 1/10 of the dataset

*Task 8:
table car_own, c(mean exp_food max kids median inc_total)

*Task 9:
scatter room kids
